# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - deploy

variables:
  # tag for runners
  s_tag: stage
  p_tag: prod


build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Install Ansible ..."
    - sudo apt install python3-pip -y
    - python3 -m pip -V
    - sudo apt install ansible ansible-lint -y
    - git clone $CI_PROJECT_URL
    - echo $GIT_CLONE_PATH
  parallel: 2

unit-test-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "Running test ..."
    - ansible --version
  parallel: 2

lint-test-job:   # This job also runs in the test stage.
  stage: test    # It can run at the same time as unit-test-job (in parallel).
  script:
    - echo "Linting code... "
    - echo $CI_PROJECT_NAME
    - ls -al
    - ansible-lint -v playbooks/*.yml -x experimental,git-latest,yaml
    - ansible-playbook playbooks/pl_service_local.yml --syntax-check
  parallel: 2

deploy-job-stage:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  environment: stage
  script:
    - echo "Deploying application..."
    - ansible-playbook playbooks/pl_service_local.yml
    - echo "Application successfully deployed."
  parallel: 2
  tags:
  - $s_tag

deploy-job-prod:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  environment: production
  script:
    - echo "Deploying application..."
    - ansible-playbook playbooks/pl_service_local.yml
    - echo "Application successfully deployed."
  parallel: 2
  when: manual
  only:
    - master
    - main
  tags:
  - $p_tag